/* $Id: I2L_menus.j,v 1.9 2003/06/02 09:41:19 richard Exp $ */

/* ******************** remains of the old 'choose by selection' mechanism, which is dead but may fly again ******************** */

TACTIC ForwardOrBackward (Forward, n, Rule) IS 
	WHEN	(LETHYP _Ah 
				(ALT	(Forward n Rule)
					(WHEN	(LETARGSEL _B  (Fail (Rule is not applicable to antecedent ' _Ah ' with argument ' _B ')))
								(Fail (Rule is not applicable to antecedent ' _Ah '))
					)
				)
			)
			(ALT	(WITHSELECTIONS Rule)
				(WHEN	(LETARGSEL _Ah (Fail (Rule is not applicable with argument ' _Ah ')))
					(Fail (Rule is not applicable))
				)
			)

/* ******************** tactics to apply rules pseudo-forwards ******************** */

TACTIC ForwardCut (n,rule)
	CUTIN (ForwardUncut n rule)

TACTIC ForwardUncut (n,Rule)
	WHEN	(LETHYP _Ah 
				(LETGOALPATH G (WITHARGSEL Rule) (GOALPATH (SUBGOAL G n)) (WITHHYPSEL hyp) (GOALPATH G) NEXTGOAL)
			)
			/* If LETHYP fails at this point, we had better have a singleton LHS.*/
			(LETLHS _Ah
				(LETGOALPATH G (WITHARGSEL Rule) (GOALPATH (SUBGOAL G n)) 
					(LETGOAL _Ag 
						(ALT (UNIFY _Ag _Ah) (Fail ("Error in I2L Jape (can't unify lhs %t with rhs %t in ForwardUncut). Tell Richard.", _Ah, _Ag)))
						(ANY hyp)
					) 
					(GOALPATH G) 
					NEXTGOAL
				)
			)
			(Fail "Error in I2L Jape (ForwardUncut falls through). Tell Richard.")

/* ******************** tactics to deal with variables in quantification rules ******************** */

TACTIC "e forward" IS
	WHEN	(LETHYP2 (actual _i) (_x._A) ("e forward step" (_x._A) _i))
			(LETHYP (_x._A) ("e forward moan" ("You only selected %t.", _x._A)))
			(LETHYP (actual _i) ("e forward moan" ("You only selected %t.", actual _i)))
			(LETHYPS _As ("e forward moan" ("You selected %l.", (_As, ", ", " and "))))
			(LETGOAL (_x._A)
				(ALERT	("To make a e step forward, you must select an antecedent of the form x.A, and \
						\also a pseudo-assumption of the form actual i. You didn't select any antecedents, but the \
						\current conclusion is %t, which could be used to make a i step backwards.\
						\\nDid you perhaps mean to make a backward step with i?", _x._A)
						("OK",STOP) ("Huh?",SEQ Explainantecedentandconclusionwords STOP)
				)
			)
			("e forward moan" "You didn't select any antecedents")
			
TACTIC "e forward step" (P, i) IS
	Noarg	(CUTIN 
				"e"
				(WITHHYPSEL (hyp P))
				(WITHHYPSEL (hyp (actual i)))
			)

TACTIC "e forward moan" (extra) IS
	ALERT	("To make a e step forward, you must select an antecedent of the form x.A, and \
			\also a pseudo-assumption of the form actual i.%s",extra)
			("OK", STOP) ("Huh?", SEQ Explainvariables STOP)

TACTIC "e forward" IS
	ForwardUncut 0 "e"
	
TACTIC "i backward" IS  
	WHEN	(LETCONC (_x._A)
				("i backward hypcheck" "i backward step" ("You selected the conclusion %t (which is ok), but ", _x._A))
			)
			(LETCONC _A
				("i backward selection moan" (" You selected the conclusion %t.", _A))
			)
			(LETGOAL (_x._A)
				("i backward hypcheck" "i backward step" ("The conclusion is %t (which is ok), but", _x._A))
			)
			(LETGOAL _A /* the wrong goal, sob */
				("i backward selection moan" (" The conclusion you are working on is %t.", _A))
			)
			(LETOPENSUBGOAL G (_x._A) /* there is something they might have chosen */
				("i backward hypcheck" 
					(ALERT ("To make an i step backwards, you have to use a conclusion of the form \
								\x.A, and select a pseudo-assumption of the form actual i. You selected the \
								\pseudo-assumption, but you didn't click on the conclusion %t. Would you like to proceed \
								\with the step using %t?\
								\\n\n(You can avoid this message in the future if you always click on the relevant \
								\conclusion before you make the step.)", _x._A, _x._A)
								("OK", SEQ (GOALPATH G) "i backward step")  ("Huh?", SEQ Explainvariables STOP) ("Cancel", STOP)
					)
					("You didn't select the unproved conclusion %t, and", _x._A))
			)
			("i backward hypcheck" ("i backward selection moan" " You didn't make any conclusion selection.") 
				("You didn't make any conclusion selection, and ")
			)

TACTIC "i backward step" (i) IS
	Noarg	(SEQ
				"i"
				fstep 
				(WITHHYPSEL (hyp (actual i)))
			)
			"i"

TACTIC "i backward selection moan" (stuff) IS
	ALERT	("To make an i step backwards, you have to use a conclusion of the form \
			\x.A, and select a pseudo-assumption of the form actual i.%s", stuff)
			("OK", STOP) ("Huh?", SEQ Explainvariables STOP)

TACTIC "i backward hypcheck" (action, gmess) IS
	WHEN	(LETHYP (actual _i) (action _i)) /* the right antecedent - hoorah! */
			(LETHYP (_x._A) /* looks like a forward step */
				(ALERT	("To make an i step backwards, you have to select a conclusion of the form \
						\x.A, and a pseudo-assumption of the form actual i. You selected \
						\the antecedent %t, which would fit e going forward.\
						\\nWould you like to make the forward step instead?",_x._A)
						("Forward", "e forward") ("Huh?", SEQ Explainvariables STOP) ("Cancel", STOP)
				)
			)
			(LETHYP _A /* the wrong antecedent */
				("i backward selection moan" ("%s you selected the antecedent %t instead.", gmess, _A))
			)
			(LETHYPS _As /* more than one */
				("i backward selection moan" ("%s you selected more than one antecedent  %l.", gmess, (_As, ", ", " and ")) )
			)
			("i backward selection moan" ("%s you didn't select an antecedent.", gmess))

/* ******************** most rules don't want arguments ******************** */

TACTIC Noarg (rule, stepname) IS
	WHEN	(LETARGTEXT arg 
				(ALERT	("The %s rule doesn't need an argument, but you text-selected %s. \
						\Do you want to go on with the step, ignoring the text-selection?", stepname, arg)
						("OK", rule)
						("Cancel", STOP)
				)
			)
			rule

TACTIC SingleorNoarg (rule, stepname) IS 
	WHEN	(LETARGSEL _A (WITHARGSEL rule))
			(LETMULTIARG _As 
				(ALERT	("The %s rule can accept a single argument. You text-selected %l, which is more than \
						\it can deal with. Cancel some or all of your text selections and try again.", stepname, _As)
						("OK", STOP)
				)
			)
			rule

/* ******************** tactics for rules that only work backwards ******************** */

TACTIC BackwardOnlyA (pattern, action, stepname, shape) IS BackwardOnly pattern action stepname shape "only makes sense working backwards"

TACTIC BackwardOnlyB (pattern, action, stepname, shape) IS BackwardOnly pattern action stepname shape "doesn't work backwards in I2L Jape yet"

TACTIC BackwardOnlyC (pattern, action, stepname, shape) IS BackwardOnly pattern action stepname shape "can also be used forward -- see the Forward menu"

MACRO BackwardOnly (pattern, action, stepname, shape, explain) IS
	WHEN	(LETGOAL pattern 
				(WHEN	(LETHYP _Ah (BackwardOnly2 stepname action explain _Ah))
						(WITHSELECTIONS action)
				)
			)
			(LETGOAL _A (FailBackwardWrongGoal stepname shape))
			(ComplainBackward pattern stepname shape)

TACTIC BackwardOnly2 (stepname, action, explain, _Ah) IS /* oh for a binding mechanism other than tactic application ... */
	WHEN	(LETCONC _Ac (BackwardOnly3 stepname action explain _Ah _Ac ", selecting"))
			(LETRHS _Ac  /* can't fail */(BackwardOnly3 stepname action explain _Ah _Ac " from"))

TACTIC BackwardOnly3 (stepname, action, explain, _Ah, _Ac, stuff) IS /* Oh for tactic nesting ... */
	ALERT	("You asked for a backward step with the %s rule%s the conclusion %s, \
			 \but you also selected the antecedent %s. \
			 \\n\nThe %s rule %s. \
			 \ \n\nDo you want to go on with the backward step from %s -- ignoring %s?", 
			stepname, stuff,  _Ac, _Ah, stepname, explain, _Ac, _Ah)
			("Backward", action) STOP

TACTIC FailBackwardWrongGoal (stepname, shape) IS
	WHEN	(LETCONC _Ac (FailBackwardWrongGoal2 stepname shape _Ac "You selected"))
			(LETRHS _Ac (FailBackwardWrongGoal2 stepname shape _Ac "The current conclusion is"))

TACTIC FailBackwardWrongGoal2 (stepname, shape, Pc, stuff) IS	
	ALERT	("To make a backward step with %s, the conclusion must be of the form %s. \
			\\n%s %s, which isn't of that form.", stepname, shape, stuff, Pc)
			("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP )

/* ******************** tactic for rules that allow a hypothesis selection, but must have the right goal ******************** */

TACTIC BackwardWithHyp (gpattern, action, stepname, shape) IS
	WHEN	(LETGOAL gpattern (WITHSELECTIONS action))
				(LETGOAL _A (FailBackwardWrongGoal stepname shape))
				(SEQ 
					(ComplainBackwardDeadConc gpattern stepname shape)
					(ComplainBackwardBadGoal gpattern stepname shape)
					(Fail	("Error in I2L Jape (no error message in BackwardWithHyp [%t] %s [%t]). Tell Richard.",gpattern,stepname,shape))
				)

/* ******************** tactics to deal with bad backward selections ******************** */

MACRO ComplainBackward (pattern, stepname, shape) IS
	ALT 
		(ComplainBackwardDeadConc pattern stepname shape)
		(ComplainBackwardHypSel pattern stepname shape)
		(ComplainBackwardBadGoal pattern stepname shape)
		(Fail	("Error in I2L Jape (no error message in ComplainBackward [%t] %s [%t]). Tell Richard.",pattern,stepname,shape))
		
MACRO ComplainBackwardDeadConc(pattern, stepname, shape) IS
	WHEN	(LETCONC pattern /* dead conclusion, right shape */
				(LETCONC _Ac
					(ALERT	("You selected the already-proved conclusion %t.\
								\\nTo make a backward step with %s, select an unproved conclusion.", _Ac, stepname)
								("OK", STOP) ("Huh?", Explainunprovedconclusionwords)
					)
				)
			)
			(LETCONC _Ac /* dead conclusion, wrong shape */
				(FailBackwardWrongGoal stepname shape)
			)
				
MACRO ComplainBackwardHypSel(pattern, stepname, shape) IS
	(LETHYP _Ah
		(ALERT	("You selected the antecedent %t.\n\
					\To make a backward %s step, select an unproved conclusion of the \
					\form %s, and don't select an antecedent.", _Ah, stepname, shape)
					("OK", STOP) ("Huh?", Explainantecedentandconclusionwords)
		)
	)
	(LETHYPS _Ahs
		(ALERT	("You selected the antecedents %l.\n\
					\To make a backward %s step, select an unproved conclusion of the \
					\form %s, and don't select any antecedents.", (_Ahs, ", ", " and "), stepname, shape)
					("OK", STOP) ("Huh?", Explainantecedentandconclusionwords)
		)
	)

MACRO ComplainBackwardBadGoal(pattern, stepname, shape) IS
	(LETOPENSUBGOAL G _Ag
		(Fail	("Error in I2L Jape (open subgoal in ComplainBackward [%t] %s [%t]). Tell Richard.",pattern,stepname,shape))
	)
	(LETOPENSUBGOALS _Ags
		(ALERT	("There is more than one unproved conclusion. Please select one to show \
					\Jape where to apply the %s step.", stepname)
					("OK", STOP) 
					("Huh?", Fail	("The unproved conclusions (formulae below a line of dots) in your proof \
										\are %l.\nSelect one of them to tell Jape where to make the %s step.",
										(_Ags,", "," and "), stepname)
					)
		)
	)
	(ALERT "The proof is finished -- there are no unproved conclusions left."
				("OK", STOP) ("Huh?", Explainunprovedconclusionwords)
	)

/* ******************** special one for hyp ******************** */

TACTIC "try hyp" (Ph, Pg, mess) IS
	SEQ	(ALT (UNIFY Ph Pg)
			(BADUNIFY X Y (ALERT ("%s, because the formula structures don't match.", mess) ("OK", STOP)))
			(BADMATCH X Y (ALERT ("%s, because to do so would change the proof (you shouldn't see this message).", mess) ("OK", STOP)))
			(BADPROVISO X Y P 
				(ALERT ("%s, because to do so would smuggle a variable out of its scope \
							\(see the proviso %s in the proviso pane).", mess, P)
							("OK", STOP)
							("Huh?", (ALERT "The proviso i NOTIN _B (for example) appears when the unknown _B occurs both inside \
													\AND outside the scope box for i. It means that nothing unified with _B can contain \
													\the variable i, because that would produce an occurrence of i outside its scope box."
													("OK", STOP)
										)
							)
				) 
			)
		)
		(ALT (WITHHYPSEL hyp)	
			(ALERT "I2L Jape error (hyp failed in hyptac). Tell Richard" ("OK", STOP))
		)

TACTIC hyptac IS
	WHEN	(LETHYP _Ah /* demand antecedent selection to avoid multi-hyp messages ... */
				(WHEN	(LETCONC _Ag ("try hyp" _Ah _Ag ("%t and %t don't unify", _Ah, _Ag)))
						(LETOPENSUBGOAL G _Ag 
							/* shall we just do it if we can? */
							(GOALPATH G) 
							("try hyp" _Ah _Ag  ("%t and %t (the only relevant unproved conclusion) don't unify", _Ah, _Ag))
						)
						(LETOPENSUBGOALS _Ags
							(ALERT	("Please select one of the unproved conclusions %l to unify with the antecedent %t.", 
									(_Ags, ", ", " or "), _Ah) ("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP )
							)
						)
						(ALERT	("There aren't any unproved conclusions relevant to the antecedent %t.", _Ah)
								("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP )
						)
				)
			)
			(LETGOAL _Ac 
				(WHEN	(LETLHS ()
							(ALERT	("You can't use hyp to prove %t, because there aren't any relevant antecedents.", _Ac)
									("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP )
							)
						)
						(ALERT	("Please select an antecedent to unify with the conclusion %s.", _Ac)
								("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP )
						)
				)
			)
			(ALERT	"To use hyp, you have to select a conclusion and an antecedent. You didn't select anything"
					("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP )
			)
				
/* ******************** the Backward menu ******************** */

MENU "Atras" IS
	ENTRY	"i" IS BackwardOnlyA (QUOTE (_A_B)) (Noarg "i" "i") "i" "AB"
	ENTRY	"i" IS BackwardOnlyC (QUOTE (_A_B)) (Noarg "i backward" "i") "i"  "AB"
	ENTRY	"i1" IS BackwardOnlyC (QUOTE (_A_B)) (Noarg (LAYOUT " intro" (0) "i1" fstep) " intro") " intro" "AB"
	ENTRY	"i2" IS BackwardOnlyC (QUOTE (_A_B)) (Noarg (LAYOUT " intro" (0) "i2" fstep) " intro") " intro" "AB"
	ENTRY	"i" IS BackwardOnlyA (QUOTE (_A)) (WITHARGSEL "i") "i" "A" 
	ENTRY	"i" IS BackwardOnlyC (QUOTE (_A_B)) (Noarg "i backward" "i") "i"  "AB"
	ENTRY	"i" IS BackwardOnlyA (QUOTE (_x._A)) (Noarg "i" "i") "i" "x.A" 
	ENTRY	"i"	"i backward"
		
	SEPARATOR
	
	ENTRY	"e"	IS 
		WHEN 
			(LETHYP2 _A (_A) 
				(ALERT	("To make a backward step with e you don't have to select any antecedents. \
						\You selected %t and %t, which would fit a forward step. Since it works better \
						\that way, would you like to use e going forward?", _A, _A)
						("Forward", "e forward") ("Cancel", STOP)
				)
			)
			(LETHYP (_A) 
				(BackwardWithHyp  (Noarg (SEQ ("e") fstep (WITHHYPSEL (hyp (_A)))) "e") "e" "")
			)
			(BackwardOnlyC  (SEQ (SingleorNoarg "e" "e") fstep fstep) "e" "")
	ENTRY	"e"				IS BackwardOnlyA (QUOTE _A) (Noarg "e" "e") "e" "A"
	ENTRY	"e"				IS BackwardOnlyA (QUOTE _A) (Noarg "e" "e") "e" "A"

	SEPARATOR
	ENTRY	hyp 	IS Noarg hyptac hyp

END
	
MACRO trueforward(tac) IS
	LETGOAL _A (CUTIN (LETGOAL _B (UNIFY _A _B) tac)) (ANY (MATCH hyp))
		
TACTIC fstep IS
	ALT (ANY (MATCH hyp)) (trueforward SKIP) /* avoid nasty 'hyp matches two ways', I hope */
	
TACTIC "i backward" IS
	WHEN	(LETGOAL (_A_B) /* bound to work, surely? */
					"i" fstep fstep
			)
			(ALERT "i backward tactic failed. Tell Richard.")
			
TACTIC "i backward" IS
	WHEN	(LETGOAL (_A_B) /* bound to work, surely? */
					"i" fstep fstep
			)
			(ALERT "i backward tactic failed. Tell Richard.")
				
/* ******************** tactics to check that a rule can be applied forward ******************** */

TACTIC Forward (fpat, action, frule, brule, shape) IS 
	Forward2 fpat  action  fpat  frule  brule  shape 

MACRO Forward2 (fpat, action, bpat, frule, brule, shape) IS
	WHEN	(LETHYP fpat action)
			(LETLHS fpat action) /* why not? */
			(LETHYP _Ah (FailForwardWrongHyp frule shape _Ah))
			(FailForward bpat frule brule (" of the form %s", shape))

MACRO FailForward (bpat, frule, brule, explainhyp) IS
	WHEN	(LETGOAL bpat 
				(WHEN	(LETCONC _Ac (FailForwardButBackwardPoss frule brule explainhyp ("You did select the conclusion formula %s", _Ac))) 
						(FailForwardButBackwardPoss frule brule  explainhyp ("The current conclusion formula is %s", bpat))
				)
			)
			(FailForwardNoHyp frule explainhyp "")

TACTIC FailForwardButBackwardPoss (frule, brule, explainhyp, explainconc) IS
	FailForwardNoHyp frule explainhyp 
		("\n\n(%s, which would fit %s backwards -- did you perhaps mean to work backwards?)", explainconc, brule)

TACTIC FailForwardWrongHyp (stepname, shape, Ph) IS
	ALERT	("To make a forward step with %s you must select something of the form %s. \
			\\nYou selected %s, which isn't of that form.", stepname, shape, Ph)
			("OK", STOP) 

TACTIC FailForwardNoHyp (stepname, explainhyp, extra) IS
	ALERT	("To make a forward step with %s you must select a formula to work forward from.\
			\\nYou didn't.%s", stepname, extra)
			("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )

/* ******************** special one for rules which don't care about antecedent shape  ******************** */

TACTIC " introforward" (rule) IS
	WHEN	(LETHYP _A (ForwardCut 0 (LAYOUT " intro" (0) (WITHARGSEL rule))))
			(FailForwardNoHyp " intro" "" "")

TACTIC "i forward"  IS
	WHEN	(LETHYP2 _A _B
					(ALERT	("i going forward is visually ambiguous  that is, it can be carried out either way round. \
						             \\nDo you want to\n\
						             \\n(a)    Make %t%t, or \
						             \\n(b)    Make %t%t.", _A, _B, _B, _A)
						             ("(a)", (CUTIN	"i" (ANY (WITHHYPSEL (hyp _A))) (ANY (WITHHYPSEL (hyp _B)))))
						             ("(b)", (CUTIN	"i" (ANY (WITHHYPSEL (hyp _B))) (ANY (WITHHYPSEL (hyp _A)))))
						             ("Cancel", STOP)
					)
				)
				(LETHYP _A 
					(ALERT	("To make a forward step with i, it's necessary to select TWO antecedent formul to combine. \
							\You only selected %t.", _A)
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
					)
				) 
				(LETHYPS _As 
					(ALERT	("To make a forward step with i, it's necessary to select only two antecedent formul to combine. \
							\You selected %l.", (_As, ", ", " and "))
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
					)
				) 
				(LETGOAL (_A_B)
					(ALERT	("To make a forward step with i, it's necessary to select TWO antecedent formul to combine. \
							\You didnt select any at all.\
							\\n\nHowever, the current conclusion %t would fit i going backwards. Did you perhaps mean to \
							\make a backward step?", _A_B)
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
					)
				)
				(ALERT	("To make a forward step with i, it's necessary to select TWO antecedent formul to combine. \
						\You didnt select any at all.")
						("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
				)

/* TACTIC "i forward(L)"(arg) IS 
	ForwardCut 0 ("i"[B\arg])

TACTIC "i forward(R)"(arg) IS 
	ForwardCut 0 ("i"[A\arg])
*/

/* this tactic is so horrible gesturally that even though it works I've taken it out of the Forward menu, and commented it out.

TACTIC "i forward" IS
	WHEN	(LETHYP (actual _i)
				(WHEN
					(LETHYPSUBSTSEL (_P[_x\_i1]) 
						("i forward checkvar" _i _i1) 
						("i forward complain" 
							(" (you only selected actual %t)", _i) 
							(" (as you did). Sorry to be so fussy, but please click on %t and try again", _P[_x\_i1])
						)
					)
					("i forward checktextsel" (" (you only selected actual %t)", _i))
				)
			)
			(LETHYP _A
				("i forward checktextsel" (" (you selected %t)", _A))
			)
			(LETHYP2 (actual _i) _A
				(WHEN
					(LETHYPSUBSTSEL (_P[_x\_i1])
						("i forward checksamehyp" _A (_P[_x\_i1]) _i1)
						("i forward checkvar" _i _i1) 
						("i forward doit" _A _x _i1 )
					)
					("i forward checktextsel" " (as you did)")
				)
			)
			(LETHYPS _As
				("i forward checktextsel" (" (you selected %l)", _As))
			)
			("i forward checktextsel" " (you didn't select any antecedents)")

TACTIC "i forward checktextsel" (varstuff) IS
	WHEN	(LETHYPSUBSTSEL (_P[_x\_i1]) 
				("i forward complain" varstuff " (as you did)")
			)
			(LETHYPSUBSTSEL (_P[_x\_B]) 
				("i forward complain" varstuff (" (your text-selection %t isn't a variable)", _B))
			)
			(LETSUBSTSEL (_P[_x\_B]) 
				("i forward complain" varstuff (" (your text-selection %t isn't in an antecedent)", _B))
			)
			(LETARGTEXT i
				("i forward complain" varstuff (" (your text-selection %s isn't a subformula)", i))
			)
			(SEQ
				("i forward complain" varstuff (" (you didn't text-select anything, or you text-selected several different things)"))
			)

MACRO "i forward checksamehyp" (h, sel, i) IS
	WHEN	(LETMATCH h sel SKIP)
			("i forward complain" " (as you did)" (" (your text selection %t isn't inside the antecedent %t)", i, h))

MACRO "i forward checkvar"(i,j) IS
	WHEN	(LETMATCH i j SKIP)
			("i forward complain" (" (you selected actual %t)",i) (" (you text-selected instance(s) of %t, which doesn't match %t)", j, i))

MACRO "i forward doit" (P1,x1,i1) IS
	(CUTIN "i" (WITHSUBSTSEL hyp) (WITHHYPSEL (hyp (actual i1))))

TACTIC "i forward complain"(varstuff, selstuff) IS
	SEQ
		(ALERT	("To make an i step forward you have to select an assumption like actual i and also \
				\an antecedent formula in its scope%s,\
				\and text-select instances of the variable in that formula%s.",
				varstuff, selstuff)
		)
		STOP
				
 */
 
/* ******************** messages about bad forward selections ******************** */

TACTIC BadForward (pattern, stepname, shape) IS 
	BadForward2 pattern stepname shape (" of the form %s", shape)

MACRO BadForward2(pattern, stepname, shape, stuff) IS
	WHEN	(LETHYP pattern /* right antecedent, other things wrong */ 
				BadForward3 pattern stepname shape stuff
			)
			(LETHYP _Ah /* wrong antecedent, other things wrong as well */
				(FailForwardWrongHyp stepname shape _Ah)
			)
			/* no antecedent at all -- just complain about that */
			(FailForwardNoHyp stepname stuff "")

TACTIC BadForward3(sel, stepname) IS
	WHEN	(LETOPENSUBGOALS _Ags
				(ALERT	("There is more than one unproved conclusion (formula below a line of dots) \
						\associated with the antecedent %t. \
						\\nSelect one of them (%l) before you make a forward step.", sel, (_Ags, ", ", " or "))
						("OK", SKIP) ("Huh?", ExplainHypMulti stepname sel)
				)
			)
			(LETOPENSUBGOAL G _Ag
				(ALERT ("Single subgoal in BadForward3. Error in I2LJape -- tell Richard."))
			)
			(ALERT	("There are no unproved conclusions associated with the antecedent %t.", sel)
						("OK", SKIP) ("Huh?",  ExplainDeadHyp stepname sel)
			)

/* ******************** the Forward menu ******************** */

TACTIC "e forward" IS
	WHEN	(LETHYP2 _A (_A_B) 
				(Noarg (CUTIN "e" (WITHHYPSEL (hyp (_A_B))) (WITHHYPSEL (hyp _A))) "e")
			)
			(LETHYP2 _C (_A_B)
				("e forward fail"
					(" You selected %t, which is of the form AB, but your other selection %t doesn't match %t.", _A_B, _C, _A)
				)
			)
			(LETHYP2 _A _B
				("e forward fail" (" Neither of your selections (%t and %t) is of the form AB.", _A, _B))
			)
			(LETHYP (_A_B) 
				(WHEN (LETCONC _C (Noarg (CUTIN "e" (WITHHYPSEL hyp) fstep) "e"))
							("e forward fail" (" You only selected %t.", _A_B))
				)
			)
			(LETHYP _A
				("e forward fail" (" You selected %t, which isn't of the form AB.", _A))
			)
			(LETHYPS _A
				("e forward fail" (" You selected too many antecedents  %l.", (_A, ", ", " and ")))
			)
			("e forward fail" (" You didn't select anything."))
			

TACTIC "e forward fail" (extra) IS
		Fail	("To make a forward step with e you must select something of the form AB, \
			\and something which matches A (or a target conclusion).%s", extra)

/*
TACTIC "MT forward" IS
	WHEN	(LETHYP2 (_B) (_A_B) 
				(Noarg (CUTIN "MT" (WITHHYPSEL (hyp (_A_B))) (WITHHYPSEL (hyp (_B)))) "MT")
			)
			(LETHYP2 _C (_A_B)
				("MT forward fail"
					(" You selected %t, which is of the form AB, but your other selection %t doesn't match %t.", _A_B, _C, _B)
				)
			)
			(LETHYP2 _A _B
				("MT forward fail" (" Neither of your selections (%t and %t) is of the form AB.", _A, _B))
			)
			(LETHYP (_A_B) 
				(WHEN (LETCONC _C (Noarg (CUTIN "MT" (WITHHYPSEL hyp) fstep) "MT"))
							("MT forward fail" (" You only selected %t.", _A_B))
				)
			)
			(LETHYP _A
				("MT forward fail" (" You selected %t, which isn't of the form AB.", _A))
			)
			(LETHYPS _A
				("MT forward fail" (" You selected too many antecedents  %l.", (_A, ", ", " and ")))
			)
			("MT forward fail" (" You didn't select anything."))
			

TACTIC "MT forward fail" (extra) IS
		Fail	("To make a forward step with MT you must select something of the form AB, \
			\and something which matches B (or a target conclusion).%s", extra)

*/

MENU Adelante IS
	ENTRY	"e"	IS "e forward"
	ENTRY	"e1" IS Forward (QUOTE (_A_B)) (ForwardCut 0 (Noarg (LAYOUT "e" (0) "e1") "e"))  "e" "i" "AB"
	ENTRY	"e2"		IS Forward (QUOTE (_A_B)) (ForwardCut 0 (Noarg (LAYOUT "e" (0) "e2") "e")) "e" "i" "AB"
	ENTRY	"e" IS Forward (QUOTE (_A_B)) (Noarg ("targeted forward" (ForwardUncut 0 "e") "e") "e") "e" " intro" "AB"
	ENTRY   "e" IS "e forward"
	ENTRY	"e" IS Forward   "e forward" "e" "e" 
	ENTRY   "e" IS Forward (QUOTE (_A)) (ForwardCut 0 (Noarg (LAYOUT "e" (0) "e") "e"))  "e" "i" "A"
	ENTRY	"e1" IS Forward (QUOTE (_A_B)) (ForwardCut 0 (Noarg (LAYOUT "e" (0) "e1") "e"))  "e" "i" "AB"
	ENTRY	"e2" IS Forward (QUOTE (_A_B)) (ForwardCut 0 (Noarg (LAYOUT "e" (0) "e2") "e"))  "e" "i" "AB"
	ENTRY	"e" IS "e forward"
	ENTRY	"e"	IS Forward (QUOTE (_x._A)) (Noarg ("targeted forward" (ForwardUncut 0 "e") "e") "e") "e" "i" "x.A"

	SEPARATOR
	ENTRY	"i" IS "i forward"
	ENTRY	"i1" IS " introforward" "i1"
	ENTRY	"i2" IS " introforward" "i2"

	/* removed -- see comment on the tactic below
	ENTRY	"i (needs variable)"		IS "i forward"
	*/

	SEPARATOR
	ENTRY	hyp IS Noarg hyptac hyp
END

TACTIC "e forward" IS
	WHEN
		(LETGOAL _A
			"e"
			(WHEN
				(LETHYP  (WITHHYPSEL (hyp )))
				(hyp )
			)
		)
		(ForwardCut 0 (Noarg "e" "e"))

TACTIC "e forward" IS
	WHEN	(LETHYP2 _A (_A) 
				(Noarg (CUTIN "e" (WITHHYPSEL (hyp _A)) (WITHHYPSEL (hyp (_A)))) "e")
			)
			(LETHYP (_A)
				(Noarg (CUTIN "e" fstep (WITHHYPSEL (hyp (_A)))) "e")
			)
			(LETHYP2 _A _B
				(ALERT	("To make a forward step with e, it's necessary to select two antecedent formul -- one to match \
							\A, the other to match A. \
							\You selected %t and %t.", _A, _B)
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
				)
			)
			(LETHYP _A 
				(ALERT	("To make a forward step with e, it's necessary to select two antecedent formul -- one to match \
							\A, the other to match A. \
							\You only selected %t.", _A)
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
				)
			) 
			(LETHYPS _As 
				(ALERT	("To make a forward step with e, it's necessary to select only two antecedent formul to combine. \
							\You selected %l.", (_As, ", ", " and "))
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
				)
			) 
			(LETGOAL 
				(ALERT	("To make a forward step with e, it's necessary to select two antecedent formul -- one to match \
							\A, the other to match A. \
							\You didnt select any at all.\
							\\n\nHowever, the current conclusion fits e going backwards. Did you perhaps mean to \
							\make a backward step?", _A_B)
							("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
				)
			)
			(ALERT	("To make a forward step with e, it's necessary to select two antecedent formul -- one to match \
					\A, the other to match A. \
					\You didnt select any at all.")
					("OK", STOP) ("Huh?", SEQ ExplainClicks STOP )
			)

	
TACTIC "targeted forward" (action, stepname) IS
	WHEN	(LETHYP _Ah ("targeted forward 2" action stepname _Ah))
			(LETLHS _Ah ("targeted forward 2" action stepname _Ah))
			(Fail ("Error in I2LJape (e forward falls through). Tell Richard.or J.A. Alonso"))
				
TACTIC "targeted forward 2"(action, stepname, hyp) IS
	(WHEN	(LETCONC _A action) 
			(LETOPENSUBGOAL G _Ag ("targeted forward single" action stepname G hyp _Ag))
			(LETOPENSUBGOALS _As
				(ALERT	("The %s step needs a target conclusion to work towards. \
						\Please click on one of the unproved conclusions  %l  and try the \
						\%s step again.", stepname, (_As, ", ", " or "), stepname)
						("OK", STOP) ("Huh?", Explainunprovedconclusionwords)
				)
			)
			(BadForward3 hyp stepname) 
	)
MACRO "targeted forward single"(action, stepname, path, selhyp, ogoal) IS
	LETGOALPATH G1
		(WHEN	(LETMATCH path G1 action) /* just do it, it's the next line */
				(ALERT	("The %s step needs a target conclusion to work towards. \
						\There's only one unproved conclusion (%t) which is relevant to the antecedent %t \
						\which you selected.\
						\\nWould you like to proceed, using %t as the target?\
						\\n(You can avoid this message in the future if you always select the target conclusion \
						\before making the %s step.)", stepname, ogoal, selhyp, ogoal, stepname)
						("OK", SEQ (GOALPATH path) action) ("Huh?", SEQ Explainantecedentandconclusionwords STOP)
						("Cancel", STOP)
				)
		)

/* ******************** explanations ******************** */

TACTIC ExplainHypMulti (stepname, Ph) IS
	WHEN	(LETOPENSUBGOALS _Aandgs
				(ALERT	("The lines of dots in a proof-in-progress mark places where there is still work to be done. \
						\The formula just below a line of dots is an unproved conclusion (notice that those formulae \
						\don't have reasons next to them). Your job is to show that each unproved conclusion follows \
						\from the line(s) above it. \
						\\n\nYou selected the antecedent %t, and the unproved conclusions which can use that \
						\antecedent are %l. (Conclusions which can't make use of the antecedent are 'greyed out'.)\
						\\n\nIf you select one of those unproved conclusions AS WELL AS selecting %t, then Jape can make a \
						\forward step and put the new formulae that it generates just before the conclusion you selected.", 
						Ph, (_Aandgs, ", ", " and "), Ph)
						("OK", STOP) ("Huh?", SEQ Explainantecedentandconclusionwords STOP)
				)
			)
				
TACTIC ExplainDeadHyp (stepname, Ph) IS
	ALERT	("When you select an antecedent, Jape shows the unproved conclusions that can make use of it \
			\in black, and any other conclusions  proved or unproved  in grey. You can see that there are no \
			\non-grey unproved conclusions in the proof, after you selected %t. \
			\\n\n(If there are any unproved conclusions in the proof, they are greyed-out either because \
			\they are above %t, or because they are inside a box that %t is outside.)",
			Ph, Ph, Ph)
			("OK", STOP) ("Huh?", SEQ Explainunprovedconclusionwords STOP)

TACTIC ExplainClicks IS
	Fail	("Click on a formula to select it.\n\n\
		 \The red selection marking shows you how you can work with the selected formula.\n\
		 \You can make a forward step from a selection open at the bottom (a downward selection).\n\
		 \You can make a backward step from a selection open at the top (an upward selection).\n\n\
		 \If you want to control where I2L Jape writes the result of a forward step, make both a downward and \
		 \an upward selection  the result will be written just before the upward selection, above the line of three dots."
		)

TACTIC Explainantecedentandconclusionwords IS
	Fail	("When you select an antecedent, you get a downward-pointing selection (a box round the \
		\formula, open at the bottom). You work forward from an antecedent selection.\
		\\n\nUnproved conclusion formulae are written with three dots above them. \
		\When you select an unproved conclusion, you get \
		\an upward-pointing selection (a box round the formula, open at the top). You work \
		\backwards from a conclusion selection, or it can be a target for a forward step.\
		\\n\nSome formulae can be used as antecedent or as unproved conclusion. In those cases \
		\the selection box has a dotted horizontal line. Click in the bottom half of the formula to make an \
		\antecedent selection, in the top half for a conclusion selection. or antecedent.\
		\\n\nAny formula can be used as an antecedent if there are relevant unproved conclusions below it \
		\in the proof.")

TACTIC Explainunprovedconclusionwords IS
	Fail	"Lines of dots mark places where there is still work to be done. \
		\The formula just below a line of dots is an unproved conclusion. \
		\Your job is to show that each unproved conclusion follows \
		\from the line(s) above it.\
		\\nWhen there are no unproved conclusions left, the proof is finished."

TACTIC ExplainDeadConc (stepname, Pc, stuff) IS
	Fail	("In making a proof, you normally select unproved conclusions  formulae just below a line of dots, \
		\with no proof-step reason written next to them. You are allowed to select proved conclusions, however, \
		\because sometimes you want to backtrack or prune the proof.  \
		\\n\nThe conclusion %t which you selected is already proved  it has a proof-step reason written next to \
		\it  so you can't make a forward step towards it, or a backward step from it.%s", Pc, stuff)
				
TACTIC ExplainMulti (stepname, stuff) IS 
	Fail	("The lines of dots in a proof-in-progress mark places where there is still work to be done. \
		\The formula just below a line of dots is an unproved conclusion (notice that those formulae \
		\don't have reasons next to them). \
		\In this proof there's more than one line of dots, which means more than one \
		\unproved conclusion.\
		\Your job is to show that each unproved conclusion follows from the line(s) above it. \
		\\n\nJape puts the results of a forward step just before a line of dots; it puts the results of a \
		\backward step just after a line of dots. If there is more than one line of dots in the proof, \
		\you must tell it where to do its work.\
		\\n\nSo if you want to make a forward step in this proof, you must select (click on) \
		\an unproved conclusion AS WELL AS an antecedent. If you want to make a backward step,\
		\ you only need to select an unproved conclusion.%s", stuff
		)

TACTIC Explainvariables IS
ALERT	"Variables are introduced into a proof by i and/or e. They appear at the head of a box \
		\as a special pseudo-assumption actual i (this is Jape's version of scope-boxing; it uses variable \
		\names i, i1, and so on as appropriate). \
		\\n\nYou have to select one of these pseudo-assumptions each time you make a e or i step.\
		\\n\nThe box enclosing actual ... is the scope of the variable. If there are unknowns in your proof, \
		\Jape will protect the scope box \
		\by putting a proviso such as i NOTIN _B in the Provisos pane .  If you try to \
		\break the scope using hyp or Unify then Jape will stop you, quoting the proviso."
			
TACTIC Explainprovisos IS
	ALERT	"The proviso i NOTIN _B (for example) appears when the unknown _B occurs both inside \
			\AND outside variable i's scope box. It means that nothing unified with _B can contain \
			\the variable i, because that would produce an occurrence of i outside its scope box."

TACTIC CrashHypDeadConc IS
	Fail "I2L Jape error (hyp and dead conc selected). Tell Richard"
	
TACTIC CrashNoHypNoConcs IS
	Fail "I2L Jape error (no sel no concs). Tell Richard."

/* ******************** we don't like some of the automatic alerts ******************** */

PATCHALERT "double-click is not defined" 
	"Double-clicking a formula doesn't mean anything in I2L Jape: you have to select (single-click) and \
	\then choose a step from the Backward or Forward menu."
	("OK")
	
PATCHALERT "You double-clicked on a used antecedent or a proved conclusion"
	"Double-clicking a formula doesn't mean anything in I2L Jape: you have to select (single-click) and \
	\then choose a step from the Backward or Forward menu."
	("OK")

PATCHALERT "To make an i step forward"
	("OK") ("Huh?", HowToTextSelect)

PATCHALERT "The e step can accept a single argument" 
	("OK") ("Huh?", HowToTextSelect)
	
/* ******************** and we do our own (careful) unification ******************** */

MENU Edit
	ENTRY Unify IS I2Lunify
END

TACTIC I2Lunify IS
	WHEN	
	    (LETMULTIARG _As
			(ALT UNIFYARGS
		 		(BADUNIFY X Y (ALERT ("%t and %t don't unify, because the formula structures don't match.", X, Y) ("OK", STOP)))
		 		(BADMATCH X Y (ALERT ("%t and %t don't unify, because to do so would change the proof (you shouldn't see this message).", X, Y) ("OK", STOP)))
		 		(BADPROVISO X Y P 
		 			(ALERT ("%t and %t don't unify, because to do so would smuggle a variable out of its scope \
		 						\(see the proviso %s in the proviso pane).", X, Y, P)
		 						("OK", STOP)
		 						("Huh?", SEQ Explainprovisos STOP)
		 			) 
		 		)
			 )
		)
		(SEQ (ALERT "To use Unify, you must text-select more than one formula.") STOP)

/* this hack to get at HowToTextSelect from within a tactic -- I must do this properly asap */
PATCHALERT "To use Unify, "
	("OK") ("Huh?", HowToTextSelect)

/*** Reglas derivadas ***/

TACTIC Fail(x) IS (SEQ (ALERT x) FAIL)

TACTIC ForwardCut1 (n,rule)
   SEQ cut (ForwardUncut1 n rule)

TACTIC ForwardUncut1 (n,rule)
   (LETGOALPATH G
                (WITHARGSEL rule)
                (GOALPATH (SUBGOAL G n))
                (WITHHYPSEL hyp)
                (GOALPATH G)
                NEXTGOAL)

TACTIC ForwardOrBackward (Forward, n, rule) IS 
   WHEN
    (LETHYP _P 
            (ALT (Forward n rule)
                 (WHEN (LETARGSEL _Q 
                                  (Fail (no aplicable a la premisa ' _P ' con argumento ' _Q ')))
                       (Fail (regla no aplicable a la premisa ' _P ')))))
    (ALT (WITHSELECTIONS rule)
         (WHEN (LETARGSEL _P (Fail (regla no aplicable con argumento ' _P ')))
               (Fail (regla no aplicable))))

TACTIC TheoremForwardOrBackward(thm) IS
  WHEN	(LETHYP _P cut (ALT (WITHSELECTIONS thm) (RESOLVE (WITHSELECTIONS thm))))
		(ALT (WITHSELECTIONS thm) (RESOLVE (WITHSELECTIONS thm)) 
			(SEQ cut (ALT (WITHSELECTIONS thm) (RESOLVE (WITHSELECTIONS thm)))))
 
MENU Derivadas IS
        ENTRY "MT"          IS ForwardOrBackward ForwardCut 1 "MT" 
        ENTRY "i"         "i"
        ENTRY "RAA"
        ENTRY "LEM"         IS TheoremForwardOrBackward "LEM"    
END
